
#ifndef __SRC_SERIALSTREAMRECORDER_H__
#define __SRC_SERIALSTREAMRECORDER_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

G_BEGIN_DECLS


#define MOSERIAL_TYPE_SERIAL_STREAM_RECORDER (moserial_serial_stream_recorder_get_type ())
#define MOSERIAL_SERIAL_STREAM_RECORDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MOSERIAL_TYPE_SERIAL_STREAM_RECORDER, moserialSerialStreamRecorder))
#define MOSERIAL_SERIAL_STREAM_RECORDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MOSERIAL_TYPE_SERIAL_STREAM_RECORDER, moserialSerialStreamRecorderClass))
#define MOSERIAL_IS_SERIAL_STREAM_RECORDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MOSERIAL_TYPE_SERIAL_STREAM_RECORDER))
#define MOSERIAL_IS_SERIAL_STREAM_RECORDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MOSERIAL_TYPE_SERIAL_STREAM_RECORDER))
#define MOSERIAL_SERIAL_STREAM_RECORDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MOSERIAL_TYPE_SERIAL_STREAM_RECORDER, moserialSerialStreamRecorderClass))

typedef struct _moserialSerialStreamRecorder moserialSerialStreamRecorder;
typedef struct _moserialSerialStreamRecorderClass moserialSerialStreamRecorderClass;
typedef struct _moserialSerialStreamRecorderPrivate moserialSerialStreamRecorderPrivate;

#define MOSERIAL_SERIAL_STREAM_RECORDER_TYPE_DIRECTION (moserial_serial_stream_recorder_direction_get_type ())
typedef struct _moserialParamSpecSerialStreamRecorder moserialParamSpecSerialStreamRecorder;

struct _moserialSerialStreamRecorder {
	GTypeInstance parent_instance;
	volatile int ref_count;
	moserialSerialStreamRecorderPrivate * priv;
};

struct _moserialSerialStreamRecorderClass {
	GTypeClass parent_class;
	void (*finalize) (moserialSerialStreamRecorder *self);
};

typedef enum  {
	MOSERIAL_SERIAL_STREAM_RECORDER_DIRECTION_INCOMING,
	MOSERIAL_SERIAL_STREAM_RECORDER_DIRECTION_OUTGOING,
	MOSERIAL_SERIAL_STREAM_RECORDER_DIRECTION_BOTH,
	MOSERIAL_SERIAL_STREAM_RECORDER_DIRECTION_NULL
} moserialSerialStreamRecorderDirection;

struct _moserialParamSpecSerialStreamRecorder {
	GParamSpec parent_instance;
};


GType moserial_serial_stream_recorder_direction_get_type (void);
void moserial_serial_stream_recorder_open (moserialSerialStreamRecorder* self, const char* filename, moserialSerialStreamRecorderDirection direction, GError** error);
void moserial_serial_stream_recorder_writeOutgoing (moserialSerialStreamRecorder* self, guchar data);
void moserial_serial_stream_recorder_writeIncoming (moserialSerialStreamRecorder* self, guchar data);
void moserial_serial_stream_recorder_close (moserialSerialStreamRecorder* self, gboolean launch);
moserialSerialStreamRecorder* moserial_serial_stream_recorder_construct (GType object_type);
moserialSerialStreamRecorder* moserial_serial_stream_recorder_new (void);
GParamSpec* moserial_param_spec_serial_stream_recorder (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
gpointer moserial_value_get_serial_stream_recorder (const GValue* value);
void moserial_value_set_serial_stream_recorder (GValue* value, gpointer v_object);
GType moserial_serial_stream_recorder_get_type (void);
gpointer moserial_serial_stream_recorder_ref (gpointer instance);
void moserial_serial_stream_recorder_unref (gpointer instance);


G_END_DECLS

#endif
